#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <iostream>
#include <string>
#include <locale>
#include <sstream>

#include <windows.h>
#include <direct.h>
#define GetCurrentDir _getcwd
using namespace std;

void MainWindow::setDir(char* argva) {
    argvo = argva;
}

MainWindow::MainWindow(QWidget *parent) :

    QMainWindow(parent),
    ui(new Ui::MainWindow)
{

    char cCurrentPath[FILENAME_MAX];

     GetCurrentDir(cCurrentPath, sizeof(cCurrentPath));

    cCurrentPath[sizeof(cCurrentPath) - 1] = '\0'; /* not really required */
    //char* nstring = cCurrentPath;
    printf ("The current working directory is %s", cCurrentPath);

    QString confref = "";
    confref += cCurrentPath;
    confref += "\\civftp.conf";

    printf((confref.toStdString()+"\n").c_str());

    QFile myFile(confref);
    QString line;

    if (!myFile.open(QIODevice::ReadOnly)) // Open the file
    {


/*
        wchar_t *czPath = new wchar_t [128];
        GetModuleFileName(NULL, czPath, sizeof czPath / sizeof czPath[0]);

        wcout << czPath << endl;

        wstring oldstr = L"";
        oldstr += czPath;

        ostringstream stm ;
        const ctype<char>& ctfacet =
                             use_facet< ctype<char> >( stm.getloc() ) ;
        for( size_t i=0 ; i<oldstr.size() ; ++i )
                      stm << ctfacet.narrow( oldstr[i], 0 ) ;
        string nstring = stm.str() ;
*/
        //GetModuleFileName(NULL , czPath, 128);
        //GetLongPathName(czPath, czPath,_MAX_PATH);

        //char fullpath[MAX_PATH];
        //GetModuleFileName(0,fullpath,MAX_PATH);
        QMessageBox::information(this, "Downloader",//tr("Config file error.\n%1\n%2").arg(myFile.errorString().arg(confref)));
        tr("Config fileerror.\n%1 \n %2.")
        .arg(confref).arg(myFile.errorString()));
        exit(1);
    }

    QTextStream stream( &myFile ); // Set the stream to read from myFile
    line = stream.readLine(); // this reads a line (QString) from the file

    host = "";
    login = "";
    pwd = "";
    folder = "/www/civ";
    rssfilename = "civftp.rss";
    savefilename = "PBEM.Civ5Save";
    username = "Someone";
    QString debugl = "0";
    while (line != "}") {
        QStringList datapoint = line.split("=");

        if (datapoint.at(0) == "host")
                host = datapoint.at(1);
        if (datapoint.at(0) == "login")
                login = datapoint.at(1);
        if (datapoint.at(0) == "pwd")
                pwd = datapoint.at(1);
        if (datapoint.at(0) == "folder")
                folder = datapoint.at(1);
        if (datapoint.at(0) == "rssfile")
                rssfilename = datapoint.at(1);
        if (datapoint.at(0) == "username")
                username = datapoint.at(1);
        if (datapoint.at(0) == "savefile")
                savefilename = datapoint.at(1);
        if (datapoint.at(0) == "debug")
                debugl = datapoint.at(1);
        line = stream.readLine();
    }

    myFile.close();

    ui->setupUi(this);
    if (debugl != "1")
        ui->debugList->hide();
    this->adjustSize();

    connect(ui->uploadButton , SIGNAL(clicked()), this, SLOT(Upload()));
    connect(ui->downloadButton , SIGNAL(clicked()), this, SLOT(Download()));
    connect(ui->checkButton , SIGNAL(clicked()), this, SLOT(Check()));

    ui->progressBar->setValue(0);

    doing = false;
    checking = false;

    setWindowTitle(tr("Civ FTP Tool"));
    QNetworkAccessManager* manger = new QNetworkAccessManager(this);
    manager = manger;

    QFtp* connection = new QFtp();
    QObject::connect(connection, SIGNAL(done(bool)), this, SLOT(Finished(bool)));
    connect(connection, SIGNAL(dataTransferProgress(qint64,qint64)),
            this, SLOT(updateDataReadProgress(qint64,qint64)));
    connect(connection, SIGNAL(stateChanged(int)),
            this, SLOT(stateChanged(int)));
    connection->connectToHost(host);
    connection->login(login,pwd);
    connection->cd(folder);

    //connection->connectToHost("bathingwithtoasters.com");
    //connection->login("bathingw","Dioptase-250");
    //connection->cd("/www/civ");

    ftpness = connection;
    currentstate = READY;
}

void MainWindow::stateChanged(int state) {

    QString str;
    str.append(QString("State %1").arg(state));
    ui->debugList->insertItem(0,str);
}

MainWindow::~MainWindow()
{
    delete ui;
    ftpness->close();
}

/*QString randchar() {
    static char* charset = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890";
    QString result;
    result.resize(5);
    for (int i = 0; i < 5; i++)
        result[i] = charset[rand() % 60];

    return result;
}*/

void MainWindow::Download()
{
    if (currentstate != READY) {
    ui->debugList->insertItem(0,"Busy.");
        return;
    }
    currentstate = READY;
    ui->labelOfDoom->setText("Downloading RSS File.");
    DownloadRSSFile();
//  DownloadCivFile();


}
/*

void MainWindow::Download()
{
    ui->debugList->insertItem(0,"Trying...");

    //QUrl url(urlLineEdit->text());
    //QString filename = QFileInfo(url.path()).fileName();

    QString filename = "D:\\qtSync\\testing\ folder\\thing.txt";

    if(QFile::exists(filename))
    {
            if(QMessageBox::question(this, tr("Downloader"),
                    tr("There already exists a file called %1 in "
                            "the current directory. Overwrite?").arg(filename),
                            QMessageBox::Yes|QMessageBox::No, QMessageBox::No)
                            == QMessageBox::No)
                            return;
            QFile::remove(filename);
    }

    file = new QFile(filename);
    if(!file->open(QIODevice::WriteOnly))
    {
            QMessageBox::information(this, "Downloader",
                    tr("Unable to save the file %1: %2.")
                    .arg(filename).arg(file->errorString()));
            delete file;
            file = NULL;
            return;
    }

    QNetworkRequest request;
    request.setUrl(QUrl("http://bathingwithtoasters.com/index.php"));
    request.setRawHeader("User-Agent", "MyOwnBrowser 1.0");

    QNetworkReply *repl = manager->get(request);
    reply = repl;
    //&reply = manager->get(request);
    connect(reply, SIGNAL(finished()), this, SLOT(downloadFinished()));
    connect(reply, SIGNAL(readyRead()), this, SLOT(slotReadyRead()));
    connect(reply, SIGNAL(error(QNetworkReply::NetworkError)),
            this, SLOT(slotError(QNetworkReply::NetworkError)));
    connect(reply, SIGNAL(sslErrors(QList<QSslError>)),
            this, SLOT(slotSslErrors(QList<QSslError>)));
    connect(reply, SIGNAL(downloadProgress(qint64,qint64)),
            this, SLOT(updateDataReadProgress(qint64,qint64)));
    ui->debugList->insertItem(0,"Done.");

}*/

void MainWindow::updateDataReadProgress(qint64 one,qint64 two)
{
//    ui->debugList->insertItem(0,"Progress");
//    ui->debugList->insertItem(0,QString::number(one));
//    ui->debugList->insertItem(0,QString::number(two));
    float num = 100 * (float)one / (float)two;
    if (currentstate == DOWNLOADINGCIV || currentstate == UPLOADINGCIV)
            ui->progressBar->setValue(num);
}

void MainWindow::slotReadyRead()
{
    ui->debugList->insertItem(0,"readyRead");
    if(file)
            file->write(reply->readAll());
}

void MainWindow::slotError(QNetworkReply::NetworkError error)
{

    ui->debugList->insertItem(0,"NetworkError");
    QString str;


    str.append(QString("%1").arg(error));
    ui->debugList->insertItem(0,str);

}

void MainWindow::slotSslErrors(QList<QSslError> errorlist)
{

    ui->debugList->insertItem(0,"SSL Error");

}

QDateTime MainWindow::mostRecentRSS(QString thefilename)
{
    QFile myFile(thefilename);
    QString line;

    if (myFile.open(QIODevice::ReadOnly)) // Open the file
    {
        QTextStream stream( &myFile ); // Set the stream to read from myFile
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();

        QDateTime rsstime;
        //ui->debugList->insertItem(0,line);
        /*
        rsstime = QDateTime::fromString("Thu, 25 Jan 1990 12:12:23 +0000","ddd, dd MMM yyyy hh:mm:ss +0000");
        rsstime = QDateTime::fromString("2010-03-01T07:29:20","yyyy-MM-ddThh:mm:ss");

        rsstime = QDateTime::fromString("Mon-25-Jan-1990","----dd-MMM-yyyy");
        rsstime = QDateTime::fromString("25 Jan 1990 12:12:23 +0000","dd MMM yyyy hh:mm:ss +0000");
        */
        rsstime = QDateTime::fromString(line,"ddd, dd MMM yyyy hh:mm:ss +0000");

        myFile.close();
        //return QDateTime::fromMSecsSinceEpoch(1000);
        return rsstime;

    }
    else
    {
        return QDateTime::fromMSecsSinceEpoch(1000);
    }
}

void MainWindow::Check()
{
    checking = true;
//    QDateTime rsstime = mostRecentRSS(rssfilename);
//    ui->debugList->insertItem(0,rsstime.toString("ddd, dd MMM yyyy hh:mm:ss +0000"));
    ui->labelOfDoom->setText("Downloading RSS File.");
    DownloadRSSFile();

}



void MainWindow::checkRSSData()
{
    QFile myFile(rssfilename);
    QString line;

    if (myFile.open(QIODevice::ReadOnly)) // Open the file
    {
        QTextStream stream( &myFile ); // Set the stream to read from myFile
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();
        line = stream.readLine();

        line = stream.readLine();

        line = stream.readLine();
        line = stream.readLine();
        QString lastperson = line;
        QString report = "Last move by ";
        report += lastperson;
        report += ".";
        ui->debugList->insertItem(0,report);
        ui->labelOfDoom->setText(report);

    }

    checking = false;
    currentstate = READY;
}

void MainWindow::WriteRSSFile() {
    ui->debugList->insertItem(0,"Writing RSS File");
    //QFile myFile("D:\\qtSync\\testing folder\\test.rss");
    QFile myFile(rssfilename);
    QString line;
    QDateTime nowtime = QDateTime::currentDateTime() ;

    if (myFile.open(QIODevice::WriteOnly | QIODevice::Text)) // Open the file
    {
        QTextStream stream( &myFile ); // Set the stream to read from myFile

        stream << "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
        stream << "<rss version=\"2.0\">\n";
        stream << "<channel>\n";
        stream << "<title>Civ 5 PBEM</title>\n";
        stream << "<description>The Civ 5 play-by-not-really-email game.</description>\n";
        stream << "<link>http://bathingwithtoasters.com/civ/PBEM.Civ5Save</link>\n";
        stream << "<lastBuildDate>\n";
        stream << nowtime.toString("ddd, dd MMM yyyy hh:mm:ss +0000") << '\n';
        stream << "</lastBuildDate>\n";
        stream << "<pubDate>\n";
        stream << nowtime.toString("ddd, dd MMM yyyy hh:mm:ss +0000") << '\n';
        stream << "</pubDate>\n";
        stream << "<item>\n";
        stream << "<title>New Move By\n";
        stream << username << '\n';
        stream << "</title>\n";
        stream << "<description>New things are happening.</description>\n";
        stream << "<link>http://bathingwithtoasters.com/civ/PBEM.Civ5Save</link>\n";
        stream << "<guid isPermaLink=\"false\"> 1102345</guid>\n";
        stream << "<pubDate>\n";
        stream << nowtime.toString("ddd, dd MMM yyyy hh:mm:ss +0000") << '\n';
        stream << "</pubDate>\n";
        stream << "</item>\n";
        stream << "</channel>\n";
        stream << "</rss>\n";

        myFile.close();
    }
}

/*void MainWindow::downloadFinished()
{
        ui->debugList->insertItem(0,"Download finished.");

        slotReadyRead();

        file->flush();
        file->close();

        if(reply->error())
        {
                //Download failed
                QMessageBox::information(this, "Download failed", tr("Failed: %1").arg(reply->errorString()));
        }

        reply->deleteLater();
        reply = NULL;
        delete file;
        file = NULL;
}*/

/*void MainWindow::Upload()
{
    QString filename = "D:\\qtSync\\testing\ folder\\randomfile.txt";
    file = new QFile(filename);

    ui->debugList->insertItem(0,"Trying upload...");

    QUrl uploadurl("ftp://bathingwithtoasters.com/www/civ/randomfile.txt");
    uploadurl.setUserName("bathingw");
    uploadurl.setPassword("Dioptase-250");
    uploadurl.setPort(21);
    QNetworkRequest upload(uploadurl);
    manager->put(upload, file);

    QNetworkReply *repl = manager->post(upload,file);
    reply = repl;
    //&reply = manager->get(request);
    connect(reply, SIGNAL(finished()), this, SLOT(uploadFinished()));
    connect(reply, SIGNAL(error(QNetworkReply::NetworkError)),
            this, SLOT(slotError(QNetworkReply::NetworkError)));
    connect(reply, SIGNAL(sslErrors(QList<QSslError>)),
            this, SLOT(slotSslErrors(QList<QSslError>)));
    connect(reply, SIGNAL(uploadProgress(qint64,qint64)),
            this, SLOT(updateDataReadProgress(qint64,qint64)));
    ui->debugList->insertItem(0,"Done.");


}*/

void MainWindow::Upload() {

    if (currentstate != READY) {
    ui->debugList->insertItem(0,"Busy.");
        return;
    }
    currentstate = READY;
    WriteRSSFile();
    ui->labelOfDoom->setText("Uploading Civ File.");
    UploadCivFile();
//  UploadRSSFile();

}

void MainWindow::Finished(bool error) {
    ui->debugList->insertItem(0,"Finished...");
    if (error)
        ui->debugList->insertItem(0,"Error.");

    switch (currentstate) {
    case DOWNLOADINGCIV:
        CivFileDownloaded();
        break;
    case DOWNLOADINGRSS:
        RSSFileDownloaded();
        break;
    case UPLOADINGCIV:
        CivFileUploaded();
        break;
    case UPLOADINGRSS:
        RSSFileUploaded();
        break;
    default:
        break;
    }

    ui->debugList->insertItem(0,"Ready.");

}

void MainWindow::DownloadCivFile() {
    ui->debugList->insertItem(0,"Beginning Civ file download...");
    currentstate = DOWNLOADINGCIV;

    //QString filename = "D:\\qtSync\\testing\ folder\\PBEM.Civ5Save";
    QString filename = savefilename;

    civfile = new QFile(savefilename);

    if(QFile::exists(filename))
    {
            QFile::remove(filename);
    }
    civfile = new QFile(filename);
    if(!civfile->open(QIODevice::WriteOnly))
    {
            QMessageBox::information(this, "Downloader",
                    tr("Unable to save the file %1: %2.")
                    .arg(filename).arg(civfile->errorString()));
            delete civfile;
            civfile = NULL;
            return;
    }

    ftpness->get("PBEM.Civ5Save",civfile, QFtp::Binary);
}

void MainWindow::UploadCivFile() {
    ui->debugList->insertItem(0,"Making a backup...");
    //QString filename = "D:\\qtSync\\testing\ folder\\PBEM.Civ5Save";
    civfile = new QFile(savefilename);

    QDateTime nowtime = QDateTime::currentDateTime() ;
    QString copyplace = savefilename;
    copyplace.chop(9);
    copyplace += "_";
    copyplace += nowtime.toString("yy_MM_dd_hh_mm_ss");
    copyplace += ".Civ5Save";
    civfile->copy(copyplace);
    ui->debugList->insertItem(0,"Beginning Civ file upload...");

    currentstate = UPLOADINGCIV;
    ftpness->put(civfile, "PBEM.Civ5Save", QFtp::Binary);
}

void MainWindow::CivFileDownloaded() {
    ui->debugList->insertItem(0,"Civ download finished.");

    civfile->flush();
    civfile->close();

    delete civfile;
    civfile = NULL;
    ui->labelOfDoom->setText("Ready.");
    currentstate = READY;
}

void MainWindow::CivFileUploaded() {
    ui->debugList->insertItem(0,"Civ upload finished.");
    currentstate = READY;
    ui->labelOfDoom->setText("Uploading RSS File.");
    UploadRSSFile();
}

void MainWindow::DownloadRSSFile() {
    ui->debugList->insertItem(0,"Beginnning RSS file download...");

    currentstate = DOWNLOADINGRSS;

    //QString filename = "D:\\qtSync\\testing\ folder\\civftp.rss";
    rssfile = new QFile(rssfilename);

    if(QFile::exists(rssfilename))
    {
            QFile::remove(rssfilename);
    }
    rssfile = new QFile(rssfilename);
    if(!rssfile->open(QIODevice::WriteOnly))
    {
            QMessageBox::information(this, "Downloader",
                    tr("Unable to save the file %1: %2.")
                    .arg(rssfilename).arg(rssfile->errorString()));
            delete rssfile;
            rssfile = NULL;
            return;
    }

    ftpness->get("civftp.rss",rssfile, QFtp::Binary);

}

void MainWindow::UploadRSSFile() {
    ui->debugList->insertItem(0,"Beginning RSS file upload...");
    //QString filename = "D:\\qtSync\\testing\ folder\\civftp.rss";
    rssfile = new QFile(rssfilename);

    currentstate = UPLOADINGRSS;
    ftpness->put(rssfile, "civftp.rss", QFtp::Binary);
}

void MainWindow::RSSFileDownloaded() {
    ui->debugList->insertItem(0,"RSS download finished.");
    rssfile->flush();
    rssfile->close();

    delete rssfile;
    rssfile = NULL;

    if (!checking) {
        ui->labelOfDoom->setText("Downloading Civ File.");
        DownloadCivFile();
    }
    else {
        ui->labelOfDoom->setText("Parsing RSS.");
        checkRSSData();
    }

}

void MainWindow::RSSFileUploaded() {
    ui->debugList->insertItem(0,"RSS upload finished.");
    ui->labelOfDoom->setText("Ready.");
    currentstate = READY;
}



void MainWindow::downloadFinished() {
    ui->debugList->insertItem(0,"Download finished.");

    file->flush();
    file->close();

    if(reply->error())
    {
            //Download failed
            QMessageBox::information(this, "Download failed", tr("Failed: %1").arg(reply->errorString()));
    }

    reply->deleteLater();
    reply = NULL;
    delete file;
    file = NULL;
}

void MainWindow::uploadFinished() {
        currentstate = READY;
        ui->labelOfDoom->setText("Ready.");
}
