#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

#include <QDialog>
#include <QHash>

#include <QtNetwork>
#include <QMessageBox>
#include <QThread>

class QDialogButtonBox;
class QFile;
class QFtp;
class QLabel;
class QUrlInfo;
class QNetworkSession;

enum AppStateEnum { READY, DOWNLOADINGCIV, UPLOADINGCIV, DOWNLOADINGRSS, UPLOADINGRSS };

namespace Ui {
    class MainWindow;
}


class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    AppStateEnum currentstate;
    ~MainWindow();

    char* argvo;

public slots:
    void setDir(char*);
    void Upload();
    void Download();
    void Check();
    //void replyFinished(QNetworkReply*);
    void slotReadyRead();
    void slotError(QNetworkReply::NetworkError error);
    void slotSslErrors(QList<QSslError>);
    void updateDataReadProgress(qint64,qint64);
    //void downloadFinished();
    void Finished(bool);
    void uploadFinished();
    void downloadFinished();
    void stateChanged(int);

    void DownloadCivFile();
    void UploadCivFile();
    void CivFileDownloaded();
    void CivFileUploaded();
    void DownloadRSSFile();
    void UploadRSSFile();
    void RSSFileDownloaded();
    void RSSFileUploaded();

    void WriteRSSFile();

    QDateTime mostRecentRSS(QString);
    void checkRSSData();


private:
    Ui::MainWindow *ui;
    bool doing;
    bool checking;

    QNetworkAccessManager* manager;
    QFile *file;
    QFile *civfile;
    QFile *rssfile;
    QFile *conffile;
    QNetworkReply *reply;
    QFtp* ftpness;

    QNetworkSession *networkSession;

    QString host;
    QString login;
    QString pwd;
    QString folder;
    QString rssfilename;
    QString savefilename;
    QString username;
};

#endif // MAINWINDOW_H
