//#include <windows.h>
#include <direct.h>
#define GetCurrentDir _getcwd

#include "civtray.h"
#include "ui_civtray.h"

CivTray::CivTray(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::CivTray)
{

    char cCurrentPath[FILENAME_MAX];

     GetCurrentDir(cCurrentPath, sizeof(cCurrentPath));

    cCurrentPath[sizeof(cCurrentPath) - 1] = '\0'; /* not really required */
    //char* nstring = cCurrentPath;
    printf ("The current working directory is %s", cCurrentPath);

    QString confref = "";
    confref += cCurrentPath;
    confref += "\\civftp.conf";

    runpath = cCurrentPath;

    printf((confref.toStdString()+"\n").c_str());

    QFile myFile(confref);
    QString line;

    if (!myFile.open(QIODevice::ReadOnly)) // Open the file
    {

        QMessageBox::information(this, "Downloader",tr("Config fileerror.\n%1 \n %2.")
        .arg(confref).arg(myFile.errorString()));
        exit(1);
    }

    QTextStream stream( &myFile ); // Set the stream to read from myFile
    line = stream.readLine(); // this reads a line (QString) from the file


    username = "Someone";
    webaddress = "";
    QString debugl = "0";

    while (line != "}") {
        QStringList datapoint = line.split("=");
        if (datapoint.at(0) == "debug")
                debugl = datapoint.at(1);
        if (datapoint.at(0) == "username")
                username = datapoint.at(1);
        if (datapoint.at(0) == "webaddress")
                webaddress = datapoint.at(1);
        if (datapoint.at(0) == "prevuser")
                prevuser = datapoint.at(1);

        line = stream.readLine();
    }

    myFile.close();




    ui->setupUi(this);
    if (debugl != "1")
        ui->debugList->hide();
    this->adjustSize();

    connect(ui->impatienceButton, SIGNAL(clicked()), this, SLOT(Impatience()));

    QNetworkAccessManager *manger = new QNetworkAccessManager(this);
    manager = manger;
    connect(manager, SIGNAL(finished(QNetworkReply*)),
            this, SLOT(replyFinished(QNetworkReply*)));

    latestperson = "";
    meperson = username;
    createTrayIcon();

    CheckRSS();
    QTimer *timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(CheckRSS()));
    timer->start(2*60*1000);
    ui->debugList->addItem("Beginning timer.");

}

void CivTray::Impatience() {
    ui->debugList->addItem("Impatience beginning...");
    CheckRSS();
}

void CivTray::CheckRSS() {
    QNetworkRequest request;
    request.setUrl(QUrl(webaddress));
    request.setRawHeader("User-Agent", "CivTray checker 1.0");

    reply = manager->get(request);
    connect(reply, SIGNAL(readyRead()), this, SLOT(slotReadyRead()));
    connect(reply, SIGNAL(error(QNetworkReply::NetworkError)),
            this, SLOT(slotError(QNetworkReply::NetworkError)));
    connect(reply, SIGNAL(sslErrors(QList<QSslError>)),
            this, SLOT(slotSslErrors(QList<QSslError>)));

    ui->debugList->addItem("Things...");

}

void CivTray::NewTurnNotify(QString person) {
    QString title = "New turn by "+person;
    //QSystemTrayIcon::MessageIcon icon = QSystemTrayIcon::MessageIcon(
    //        typeComboBox->itemData(typeComboBox->currentIndex()).toInt());
    trayIcon->showMessage(title, "Things are happening.");//, 0, durationSpinBox->value() * 1000);

}

void CivTray::replyFinished(QNetworkReply* repl) {

}

void CivTray::slotReadyRead() {
    ui->debugList->addItem("Ready to read data.");
    QString allthedata = QString(reply->readAll());
    QStringList allthelist = allthedata.split("\r\n");

    //for (int i = 0; i < allthelist.size(); ++i)
        ui->debugList->addItem(allthelist.at(14));
        MoveBy(allthelist.at(14));
}

void CivTray::MoveBy(QString person) {
    if (person != prevuser) trayIcon->setIcon(QIcon(runpath+"\\no.png"));
    else                    trayIcon->setIcon(QIcon(runpath+"\\yes.png"));
    //if (person == meperson) trayIcon->setIcon(QIcon("D:\\CivTray\\CivTray-build-desktop\\debug\\no.svg"));
    //else                    trayIcon->setIcon(QIcon("D:\\CivTray\\CivTray-build-desktop\\debug\\yes.svg"));
    trayIcon->show();
    ui->debugList->addItem(runpath+"\\no.png");

    if (person != latestperson && person != meperson) {
        ui->debugList->addItem("New move!");
        NewTurnNotify(person);
    } else {
        ui->debugList->addItem("Yawn.");
    }
    latestperson = person;
}

void CivTray::slotError(QNetworkReply::NetworkError nerror) {
    ui->debugList->addItem("Network error.");
}

void CivTray::slotSslErrors(QList<QSslError> errorlist) {
    ui->debugList->addItem("SSL error.");
}

CivTray::~CivTray()
{
    delete ui;
}

void CivTray::createTrayIcon()
{
    restoreAction = new QAction(tr("&Restore"), this);
    connect(restoreAction, SIGNAL(triggered()), this, SLOT(showNormal()));

    quitAction = new QAction(tr("&Quit"), this);
    connect(quitAction, SIGNAL(triggered()), qApp, SLOT(quit()));

    trayIconMenu = new QMenu(this);
    trayIconMenu->addAction(restoreAction);
    trayIconMenu->addAction(quitAction);

    trayIcon = new QSystemTrayIcon(this);
    trayIcon->setContextMenu(trayIconMenu);

    trayIcon->setIcon(QIcon(runpath+"\\no.png"));
    ui->debugList->addItem(runpath+"\\no.png");
    trayIcon->show();
}
