#ifndef CIVTRAY_H
#define CIVTRAY_H

#include <QMainWindow>
#include <QSystemTrayIcon>
#include <QDialog>
#include <QMenu>

#include <QtNetwork>
#include <QMessageBox>

QT_BEGIN_NAMESPACE
class QAction;
class QCheckBox;
class QComboBox;
class QGroupBox;
class QLabel;
class QLineEdit;
class QMenu;
class QPushButton;
class QSpinBox;
class QTextEdit;
QT_END_NAMESPACE

namespace Ui {
    class CivTray;
}

class CivTray : public QMainWindow
{
    Q_OBJECT

public:
    explicit CivTray(QWidget *parent = 0);
    ~CivTray();


    void createTrayIcon();


public slots:
    void Impatience();
    void CheckRSS();

    void replyFinished(QNetworkReply*);
    void slotReadyRead();
    void slotError(QNetworkReply::NetworkError);
    void slotSslErrors(QList<QSslError>);


private:
    void MoveBy(QString);
    void NewTurnNotify(QString);

    Ui::CivTray *ui;

    QNetworkAccessManager* manager;
    QFile *file;
    QNetworkReply *reply;

    QString latestperson;
    QString meperson;

    QAction *restoreAction;
    QAction *quitAction;

    QSystemTrayIcon *trayIcon;
    QMenu *trayIconMenu;

    QString username;
    QString prevuser;
    QString webaddress;
    QString debug;

    QString runpath;
};

#endif // CIVTRAY_H
